From 5f04fda69dec1e4eb8129aace235e289402abfcb Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 23 2021 02:41:13 +0000
Subject: [PATCH 2161/2232] Merge pull request #750 from dtolnay/pointers


Pointer to pointer, pointer to reference, reference to pointer
---

diff --git a/gen/src/write.rs b/gen/src/write.rs
index b3911c1..930ce0b 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -1173,17 +1173,31 @@ fn write_type(out: &mut OutFile, ty: &Type) {
             write!(out, ">");
         }
         Type::Ref(r) => {
-            if !r.mutable {
-                write!(out, "const ");
+            if let Type::Ptr(_) = r.inner {
+                write_type_space(out, &r.inner);
+                if !r.mutable {
+                    write!(out, "const");
+                }
+            } else {
+                if !r.mutable {
+                    write!(out, "const ");
+                }
+                write_type(out, &r.inner);
             }
-            write_type(out, &r.inner);
             write!(out, " &");
         }
         Type::Ptr(p) => {
-            if !p.mutable {
-                write!(out, "const ");
+            if let Type::Ptr(_) = p.inner {
+                write_type_space(out, &p.inner);
+                if !p.mutable {
+                    write!(out, "const");
+                }
+            } else {
+                if !p.mutable {
+                    write!(out, "const ");
+                }
+                write_type(out, &p.inner);
             }
-            write_type(out, &p.inner);
             write!(out, " *");
         }
         Type::Str(_) => {
diff --git a/syntax/check.rs b/syntax/check.rs
index 5430428..6ba6565 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -222,7 +222,7 @@ fn check_type_ref(cx: &mut Check, ty: &Ref) {
     }
 
     match ty.inner {
-        Type::Fn(_) | Type::Void(_) | Type::Ptr(_) => {}
+        Type::Fn(_) | Type::Void(_) => {}
         Type::Ref(_) => {
             cx.error(ty, "C++ does not allow references to references");
             return;
@@ -234,8 +234,13 @@ fn check_type_ref(cx: &mut Check, ty: &Ref) {
 }
 
 fn check_type_ptr(cx: &mut Check, ty: &Ptr) {
-    if let Type::Ident(_) = ty.inner {
-        return;
+    match ty.inner {
+        Type::Fn(_) | Type::Void(_) => {}
+        Type::Ref(_) => {
+            cx.error(ty, "C++ does not allow pointer to reference as a type");
+            return;
+        }
+        _ => return,
     }
 
     cx.error(ty, "unsupported pointer type");
diff --git a/tests/ui/ptr_unsupported.rs b/tests/ui/ptr_unsupported.rs
index ca1580a..9d59c03 100644
--- a/tests/ui/ptr_unsupported.rs
+++ b/tests/ui/ptr_unsupported.rs
@@ -3,9 +3,7 @@ mod ffi {
     unsafe extern "C++" {
         type C;
 
-        fn get_ptr_to_ptr() -> *mut *mut C;
         fn get_ptr_to_reference() -> *mut &C;
-        fn get_reference_to_ptr() -> &*mut C;
         fn get_uniqueptr_to_ptr() -> UniquePtr<*mut C>;
         fn get_vector_of_ptr() -> UniquePtr<CxxVector<*mut C>>;
     }
diff --git a/tests/ui/ptr_unsupported.stderr b/tests/ui/ptr_unsupported.stderr
index b5e8a78..41cea63 100644
--- a/tests/ui/ptr_unsupported.stderr
+++ b/tests/ui/ptr_unsupported.stderr
@@ -1,29 +1,17 @@
-error: unsupported pointer type
- --> $DIR/ptr_unsupported.rs:6:32
+error: C++ does not allow pointer to reference as a type
+ --> $DIR/ptr_unsupported.rs:6:38
   |
-6 |         fn get_ptr_to_ptr() -> *mut *mut C;
-  |                                ^^^^^^^^^^^
-
-error: unsupported pointer type
- --> $DIR/ptr_unsupported.rs:7:38
-  |
-7 |         fn get_ptr_to_reference() -> *mut &C;
-  |                                      ^^^^^^^
-
-error: unsupported reference type
- --> $DIR/ptr_unsupported.rs:8:38
-  |
-8 |         fn get_reference_to_ptr() -> &*mut C;
+6 |         fn get_ptr_to_reference() -> *mut &C;
   |                                      ^^^^^^^
 
 error: unsupported unique_ptr target type
- --> $DIR/ptr_unsupported.rs:9:38
+ --> $DIR/ptr_unsupported.rs:7:38
   |
-9 |         fn get_uniqueptr_to_ptr() -> UniquePtr<*mut C>;
+7 |         fn get_uniqueptr_to_ptr() -> UniquePtr<*mut C>;
   |                                      ^^^^^^^^^^^^^^^^^
 
 error: unsupported vector target type
-  --> $DIR/ptr_unsupported.rs:10:45
-   |
-10 |         fn get_vector_of_ptr() -> UniquePtr<CxxVector<*mut C>>;
-   |                                             ^^^^^^^^^^^^^^^^^^
+ --> $DIR/ptr_unsupported.rs:8:45
+  |
+8 |         fn get_vector_of_ptr() -> UniquePtr<CxxVector<*mut C>>;
+  |                                             ^^^^^^^^^^^^^^^^^^

